#!/bin/bash 

function check_framework() {


	# 檢查是否存在 WordPress 特有的檔和目錄
	if [ -f "$1/wp-config.php" ] && [ -d "$1/wp-admin" ] && [ -d "$1/wp-content" ] && [ -d "$1/wp-includes" ]
	then
		framework="WordPress"
	fi

	# 檢查是否存在 Laravel 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -f "$1/artisan" ] && [ -d "$1/app" ] && [ -d "$1/bootstrap" ] && [ -d "$1/config" ] && [ -d "$1/database" ] && [ -d "$1/public" ] && [ -d "$1/resources" ] && [ -d "$1/routes" ] && [ -d "$1/storage" ] && [ -d "$1/tests" ] && [ -d "$1/vendor" ]
	then
		framework="Laravel"
	fi

	# 檢查是否存在 CodeIgniter 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -f "$1/index.php" ] && [ -d "$1/application" ] && [ -d "$1/system" ]
	then
		framework="CodeIgniter"
	fi

	# 檢查是否存在 Symfony 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/config" ] && [ -d "$1/public" ] && [ -d "$1/src" ] && [ -d "$1/templates" ] && [ -d "$1/tests" ] && [ -d "$1/translations" ] && [ -d "$1/var" ] && [ -d "$1/vendor" ]
	then
		framework="Symfony"
	fi

	# 檢查是否存在 CakePHP 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/bin" ] && [ -d "$1/config" ] && [ -d "$1/logs" ] && [ -d "$1/plugins" ] && [ -d "$1/src" ] && [ -d "$1/tests" ] && [ -d "$1/tmp" ] && [ -d "$1/vendor" ] && [ -d "$1/webroot" ]
	then
		framework="CakePHP"
	fi

	# 檢查是否存在 ThinkPHP 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/application" ] && [ -d "$1/public" ] && [ -d "$1/thinkphp" ]
	then
		framework="ThinkPHP"
	fi	

	# 檢查是否存在 Zend 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/config" ] && [ -d "$1/data" ] && [ -d "$1/public" ] && [ -d "$1/src" ] && [ -d "$1/vendor" ]
	then
		framework="Zend"
	fi

	# 檢查是否存在 Zend 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/config" ] && [ -d "$1/data" ] && [ -d "$1/public" ] && [ -d "$1/src" ] && [ -d "$1/vendor" ]
	then
		framework="Zend"
	fi

	# 檢查是否存在 Yii 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/commands" ] && [ -d "$1/config" ] && [ -d "$1/controllers" ] && [ -d "$1/models" ] && [ -d "$1/runtime" ] && [ -d "$1/tests" ] && [ -d "$1/vendor" ]
	then
		framework="Yii"
	fi

	# 檢查是否存在 Phalcon 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/app" ] && [ -d "$1/config" ] && [ -d "$1/public" ] && [ -d "$1/src" ] && [ -d "$1/vendor" ]
	then
		framework="Phalcon"
	fi

	# 檢查是否存在 Swoft 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/app" ] && [ -d "$1/bin" ] && [ -d "$1/config" ] && [ -d "$1/public" ] && [ -d "$1/resources" ] && [ -d "$1/runtime" ] && [ -d "$1/vendor" ]
	then
		framework="Swoft"
	fi

	# 檢查是否存在 PHPixie 特有的檔和目錄
	if [ -f "$1/composer.json" ] && [ -d "$1/assets" ] && [ -d "$1/bundles" ] && [ -d "$1/core" ] && [ -d "$1/public" ] && [ -d "$1/vendor" ]
	then
		framework="PHPixie"
	fi

	if [[ -z "$framework" ]]; then
		framework="Native PHP"
	fi
	}

input_user=''
user_check_name=''
check_user_count=''
#clear
RegexUser='^[a-zA-Z][A-Za-z0-9]{1,15}+$'
#如果 在執行script時沒有帶入參數的話
if [[ -z "$1" ]];
then
        read -p "請輸入cPanel 帳號: "  input_user
        #如果輸入的資訊是空值
        if [[ -z "$input_user" ]]; then
                echo "未輸入，請重新輸入!"
                #exit 1
        #如果輸入的資訊符合正規式
        elif [[ $input_user =~ $RegexUser ]]; then
                #echo "你輸入的是正確的帳號!"

                user=$( echo ${input_user} |xargs)
        else
                echo "輸入不符合cPanel 帳號規範，請重新輸入!"
               # exit 1
        fi
else    #如果執行script時帶入的參數符合正規式
        if [[ $1 =~ $RegexUser ]]; then
                #儲存結果到變數domain內()
                user=$( echo ${1} |xargs)
        else
                echo "輸入不符合cPanel 帳號規範，請重新輸入!"
                #exit 1
        fi

fi


if [[ -z "$user" ]]; then
:

else
	user_check=$(whmapi1 --output=jsonpretty listaccts api.filter.enable=1 api.filter.a.field=user api.filter.a.arg0=$user)

	user_check_name=$(echo $user_check | jq -r '.data.acct[].user')
	if [[ -z "$user_check_name" ]]; then
		echo "經查看無此帳號，請重新輸入!"

	else
		check_user_count=1
	fi

fi




if [[  -z ${check_user_count}  ]]; then
#if [[  -z ${user_check_name}  ]]; then
:

else
#	user_database=$(whmapi1 --output=jsonpretty list_databases api.filter.enable=1 api.filter.a.field=cpuser api.filter.a.arg0=$user_check_name)
#	user_database_array=($(echo $user_database | jq -r '.data.payload[].name' |sort))
#
#        echo "cPanel 帳號: $user_check_name"
#	echo ""
#	echo "                 資料庫列表:                 "
#	echo "---------------------------------------------"
#	for array_host in ${user_database_array[*]}
#    	do
#		echo $array_host
#	echo ""
#    	done
#	echo "---------------------------------------------"
	



domain_array=$(whmapi1 --output=jsonpretty get_domain_info api.filter.enable=1 api.filter.a.field=user api.filter.a.arg0=$user_check_name)

user_domains=$(echo "$domain_array" | jq -r '.data.domains[] | "\(.domain) \(.domain_type) \(.docroot) \(.php_version)"')

# 將欄位分組輸出
echo "$user_domains" | while read DOMAIN DOMAIN_TYPE DOCROOT PHP_VERSION; do
    echo "網域: $DOMAIN"
    echo "於此帳號的網域類型: $DOMAIN_TYPE" | sed 's/main/主網域/g;s/sub/子網域/g;s/addon/附加網域/g;s/alias/寄放網域/g'
    echo "網站根目錄: $DOCROOT"
    echo "PHP 版本: $PHP_VERSION"
    framework=""
    check_framework $DOCROOT
    echo "網站框架: "$framework
    
    echo ""
done


fi


#if [[  -z ${check_user_count}  ]]; then
#if [[  -z ${user_check_name}  ]]; then
#:

#else
#	user_database=$(whmapi1 --output=jsonpretty list_mysql_databases_and_users user=${user_check_name})
#       user_database_array=($(echo $user_database | jq -r '.data.mysql_databases.mnieorz_mambo2' |sort))

#       echo $user_database
#        echo "cPanel 帳號: $user_check_name"
#       echo ""
#       echo "                 資料庫列表:                 "
#       echo "---------------------------------------------"
#       for array_host in ${user_database_array[*]}
#       do
#               echo $array_host
#       echo ""
#       done
#       echo "---------------------------------------------"
	

#fi

